<template lang="pug">
component.btn.position-relative(
    :is="tag" 
    :class="[variantClass, loadingClass]" 
    v-on="{...$listeners}" v-bind="componentBind")
    .btn__spinner(v-if="loading")
        b-spinner(small)
    .btn__content
        slot
</template>

<script>
export default {
    props: {
        variant: {
            type: String,
            default: 'primary',
        },
        tag: {
            type: String,
            default: 'button',
        },
        href: {
            type: String,
            default: '#',
        },
        disabled: {
            type: Boolean,
            default: false,
        },
        loading: {
            type: Boolean,
            default: false,
        },
    },
    computed: {
        variantClass() {
            return `btn-${this.variant}`
        },
        loadingClass() {
            return this.loading ? 'btn-loading' : ''
        },
        componentBind() {
            const bind = {
                disabled: this.disabled || this.loading,
            }
            if (this.tag === 'a') Object.assign(bind, { href: this.href })
            return bind
        },
    },
}
</script>

<style lang="scss" scoped src="./index.scss"></style>
